-- default biome functions that get called if we can't find a a specific biome that works for us
CHEST_LEVEL = 3
dofile_once("data/scripts/director_helpers.lua")
dofile_once("data/scripts/biomes/mountain/mountain.lua")

RegisterSpawnFunction( 0xffffeedd, "init" )
RegisterSpawnFunction( 0xffC4189B, "spawn_trees" )
RegisterSpawnFunction( 0xffC41820, "spawn_big_bushes" )
RegisterSpawnFunction( 0xffC41860, "spawn_vines" )
RegisterSpawnFunction( 0xffc4186a, "spawn_wasd" )
RegisterSpawnFunction( 0xffc45f7b, "spawn_wasd_trigger" )
RegisterSpawnFunction( 0xffc4186b, "spawn_mouse" )
RegisterSpawnFunction( 0xffc4187b, "spawn_mouse_trigger" )
RegisterSpawnFunction( 0xffc4187c, "spawn_grass" )
RegisterSpawnFunction( 0xffff5a0f, "spawn_music_trigger" )
RegisterSpawnFunction( 0xff80FF5A, "spawn_vines_b" )
RegisterSpawnFunction( 0xff0006ff, "spawn_bumper_strong" )
RegisterSpawnFunction( 0xffaf381a, "spawn_gravity_field" )
RegisterSpawnFunction( 0xff849714, "spawn_fan_up" )
RegisterSpawnFunction( 0xff3831cf, "spawn_fan_down" )
RegisterSpawnFunction( 0xff24975d, "spawn_vent_wheel" )
RegisterSpawnFunction( 0xff80146b, "spawn_vent_wheel_inverse" )
RegisterSpawnFunction( 0xffaf4545, "spawn_bad_thing" )
RegisterSpawnFunction( 0xff91dfc2, "spawn_coin" )
RegisterSpawnFunction( 0xff176d9f, "spawn_coin2" )
RegisterSpawnFunction( 0xffa6a737, "spawn_coin3" )
RegisterSpawnFunction( 0xff715eb6, "spawn_coin3_2" )
RegisterSpawnFunction( 0xffffbd00, "spawn_coin4" )
RegisterSpawnFunction( 0xffd511d7, "spawn_checkpoint1" )
RegisterSpawnFunction( 0xffc50dc7, "spawn_checkpoint2" )
RegisterSpawnFunction( 0xff034400, "spawn_checkpoint3" )
RegisterSpawnFunction( 0xffb71360, "spawn_checkpoint4" )
RegisterSpawnFunction( 0xffa73737, "spawn_checkpoint5" )
RegisterSpawnFunction( 0xff1cc878, "spawn_checkpoint5_2" )
RegisterSpawnFunction( 0xffa73697, "spawn_checkpoint6" )

RegisterSpawnFunction( 0xffa629d7, "spawn_spinner" )

RegisterSpawnFunction( 0xffdfc249, "spawn_moving_bumper_right" )
RegisterSpawnFunction( 0xff2b8487, "spawn_moving_bad_thing_left" )
RegisterSpawnFunction( 0xff871b7a, "spawn_moving_bad_thing_right" )
RegisterSpawnFunction( 0xff000244, "spawn_moving_bad_thing_down" )

RegisterSpawnFunction( 0xffc7ac3a, "spawn_box" )
RegisterSpawnFunction( 0xff40efae, "spawn_button" )
RegisterSpawnFunction( 0xff2bd716, "spawn_shield" )

RegisterSpawnFunction( 0xffa5cf09, "spawn_coin_shield" )
RegisterSpawnFunction( 0xffbf2984, "spawn_button2" )

RegisterSpawnFunction( 0xff3631a7, "spawn_coin_shield2" )
RegisterSpawnFunction( 0xffb76115, "spawn_button3" )

RegisterSpawnFunction( 0xff5f7a9f, "spawn_explosive_gravity_spinner" )

RegisterSpawnFunction( 0xff5f7569, "spawn_vine_monster" )

RegisterSpawnFunction( 0xff6bc774, "spawn_rock" )
RegisterSpawnFunction( 0xff5912af, "spawn_button4" )
RegisterSpawnFunction( 0xff89c77b, "spawn_shield2" )

RegisterSpawnFunction( 0xff9b9cbf, "spawn_button5" )
RegisterSpawnFunction( 0xffc78bb4, "spawn_shield3" )

RegisterSpawnFunction( 0xff247fa7, "spawn_portal" )
RegisterSpawnFunction( 0xff9c15a7, "spawn_shield5" )
RegisterSpawnFunction( 0xff7d2ddf, "spawn_boss" )
RegisterSpawnFunction( 0xff16ff0b, "spawn_bomb" )


function spawn_wands( x, y ) end

g_trees =
{
	total_prob = 0,
	{
		prob   		= 1.0,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/vegetation/tree_spruce_1.xml"
	},
	{
		prob   		= 1.0,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/vegetation/tree_spruce_2.xml"
	},
	{
		prob   		= 1.0,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/vegetation/tree_spruce_3.xml"
	},
	{
		prob   		= 1.0,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/vegetation/tree_spruce_4.xml"
	},
	{
		prob   		= 1.0,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/vegetation/tree_spruce_5.xml"
	},
}

g_big_bushes =
{
	total_prob = 0,
	{
		prob   		= 1.0,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/vegetation/plant_bush_big_1.xml"
	},
	{
		prob   		= 1.0,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/vegetation/plant_bush_big_2.xml"
	},
	{
		prob   		= 1.0,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/vegetation/plant_bush_big_3.xml"
	},
	{
		prob   		= 1.0,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/vegetation/plant_bush_big_4.xml"
	},
	{
		prob   		= 1.0,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/vegetation/plant_bush_big_5.xml"
	},
	{
		prob   		= 1.0,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/vegetation/plant_bush_1.xml"
	},
	{
		prob   		= 1.0,
		min_count	= 1,
		max_count	= 1,		
		entity 	= "data/entities/vegetation/plant_bush_2.xml"
	},
}

g_vines =
{
	total_prob = 0,
	{
		prob   		= 0.4,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/verlet_chains/vines/verlet_vine.xml"
	},
	{
		prob   		= 0.3,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/verlet_chains/vines/verlet_vine_long.xml"
	},
	{
		prob   		= 1.5,
		min_count	= 1,
		max_count	= 1,    
		entity 	= ""
	},
	{
		prob   		= 0.5,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/verlet_chains/vines/verlet_vine_short.xml"
	},
	{
		prob   		= 0.5,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/verlet_chains/vines/verlet_vine_shorter.xml"
	},
}

g_props =
{
	total_prob = 0,
	{
		prob   		= 0.2,
		min_count	= 0,
		max_count	= 0,
		offset_y 	= 0,    
		entity 	= ""
	},
	{
		prob   		= 0.5,
		min_count	= 1,
		max_count	= 1,    
		offset_y 	= 0,
		entity 	= "data/entities/props/physics_stone_01.xml"
	},
	{
		prob   		= 0.5,
		min_count	= 1,
		max_count	= 1,    
		offset_y 	= 0,
		entity 	= "data/entities/props/physics_stone_02.xml"
	},
	{
		prob   		= 0.5,
		min_count	= 1,
		max_count	= 1,    
		offset_y 	= 0,
		entity 	= "data/entities/props/physics_stone_03.xml"
	},
	{
		prob   		= 0.5,
		min_count	= 1,
		max_count	= 1,    
		offset_y 	= 0,
		entity 	= "data/entities/props/physics_stone_04.xml"
	},
}

function init( x, y, w, h )
  -- print(math.floor(x / 512))
	local load_what = math.floor(x / 512) + 3
	local load_what_y = math.floor(y / 512) + 2
	for _y=1,2 do
	  for _x=1,2 do
		local x_coord = x + (256 * (_x-1))
		local y_coord = y + (256 * (_y-1))
		local file = "mods/pinball/files/track_" .. (load_what*2-(2-_x)) .. "_" .. _y + load_what_y*2 .. ".png"
		LoadPixelScene(file, "", x_coord, y_coord, "", true)
	  end
	end
end

function spawn_trees( x, y )
	spawn( g_trees, x, y+28, 0, 0 )
end

function spawn_big_bushes( x, y )
	spawn( g_big_bushes, x, y+12, 0, 0 )
end

function spawn_vines( x, y )
	spawn( g_vines, x, y )
end

function spawn_vines_b(x, y)
	spawn(g_vines,x,y)
end

function spawn_wasd( x, y )
	if (GameGetIsGamepadConnected() == false) then
		EntityLoad( "data/entities/particles/image_emitters/controls_wasd.xml", x, y )
	else
		EntityLoad( "data/entities/particles/image_emitters/controls_stick.xml", x-1, y-1 )
	end
end

function spawn_mouse( x, y )
	if (GameGetIsGamepadConnected() == false) then
		EntityLoad( "data/entities/particles/image_emitters/controls_mouse.xml", x, y )
	else
		EntityLoad( "data/entities/particles/image_emitters/controls_lt.xml", x, y-2 )
	end
end

function spawn_wasd_trigger( x, y )
	if ( GameIsIntroPlaying() == false ) then 
		EntityLoad( "data/entities/buildings/controls_wasd_trigger.xml", x, y )
	end
end

function spawn_mouse_trigger( x, y )
	EntityLoad( "data/entities/buildings/controls_mouse_trigger.xml", x, y )
end

function spawn_grass( x, y )
	EntityLoad( "data/entities/props/mountain_left_entrance_grass.xml", x, y )
end

function spawn_potions( x, y ) end

function spawn_music_trigger( x, y )
	EntityLoad( "data/entities/buildings/music_trigger_mountain_left_entrance.xml", x, y )
end

function spawn_props(x, y)
	spawn(g_props,x,y,0,0)
end

function spawn_bumper_strong( x, y )
	EntityLoad( "mods/pinball/files/bumper_strong.xml", x, y )
end

function spawn_gravity_field( x, y )
	EntityLoad( "mods/pinball/files/gravity_field.xml", x, y )
end

function spawn_fan_up( x, y )
	EntityLoad( "mods/pinball/files/fan.xml", x, y )
end

function spawn_fan_down( x, y )
	local fan = EntityLoad( "mods/pinball/files/fan.xml", x, y )
	local var_comp = EntityGetFirstComponent( fan, "VariableStorageComponent" )
	ComponentSetValue2( var_comp, "value_float", 180 )
end

function spawn_vent_wheel( x, y )
	EntityLoad( "mods/pinball/files/vent_wheel.xml", x - 51, y -51 )
end

function spawn_vent_wheel_inverse( x, y )
	EntityLoad( "mods/pinball/files/vent_wheel_inverse.xml", x - 51, y -51 )
end

function spawn_bad_thing( x, y )
	EntityLoad( "mods/pinball/files/bad_thing.xml", x, y )
end

function spawn_coin( x, y )
	EntityLoad( "mods/pinball/files/coin.xml", x, y )
end

function spawn_checkpoint1( x, y )
	EntityLoad( "mods/pinball/files/checkpoint.xml", x, y )
end

function spawn_checkpoint2( x, y )
	EntityLoad( "mods/pinball/files/checkpoint2.xml", x, y )
end

function spawn_checkpoint3( x, y )
	EntityLoad( "mods/pinball/files/checkpoint3.xml", x, y )
end

function spawn_checkpoint4( x, y )
	EntityLoad( "mods/pinball/files/checkpoint4.xml", x, y )
end

function spawn_checkpoint5( x, y )
	EntityLoad( "mods/pinball/files/checkpoint5.xml", x, y )
end

function spawn_checkpoint5_2( x, y )
	EntityLoad( "mods/pinball/files/checkpoint5_2.xml", x, y )
end

function spawn_checkpoint6( x, y )
	EntityLoad( "mods/pinball/files/checkpoint6.xml", x, y )
end

function spawn_coin2( x, y )
	EntityLoad( "mods/pinball/files/coin2.xml", x, y )
end

function spawn_coin3( x, y )
	EntityLoad( "mods/pinball/files/coin3.xml", x, y )
end

function spawn_coin3_2( x, y )
	EntityLoad( "mods/pinball/files/coin3_2.xml", x, y )
end

function spawn_coin4( x, y )
	EntityLoad( "mods/pinball/files/coin4.xml", x, y )
end

function spawn_spinner( x, y )
	EntityLoad( "mods/pinball/files/spinner.xml", x, y )
end

function spawn_moving_bumper_right( x, y )
	EntityLoad( "mods/pinball/files/bumper_moving_right.xml", x, y )
end

function spawn_moving_bad_thing_left( x, y )
	EntityLoad( "mods/pinball/files/bad_thing_moving_left.xml", x, y )
end

function spawn_moving_bad_thing_right( x, y )
	EntityLoad( "mods/pinball/files/bad_thing_moving_right.xml", x, y )
end

function spawn_moving_bad_thing_down( x, y )
	EntityLoad( "mods/pinball/files/bad_thing_moving_down.xml", x, y )
end

function spawn_box( x, y )
	EntityLoad( "mods/pinball/files/box.xml", x, y )
end

function spawn_button( x, y )
	EntityLoad( "mods/pinball/files/button.xml", x, y )
end

function spawn_shield( x, y )
	EntityLoad( "mods/pinball/files/shield.xml", x, y )
end

function spawn_coin_shield( x, y )
	EntityLoad( "mods/pinball/files/coin_shield.xml", x, y )
end

function spawn_button2( x, y )
	EntityLoad( "mods/pinball/files/button2.xml", x, y )
end

function spawn_coin_shield2( x, y )
	EntityLoad( "mods/pinball/files/coin_shield2.xml", x, y )
end

function spawn_button3( x, y )
	EntityLoad( "mods/pinball/files/button3.xml", x, y )
end

function spawn_explosive_gravity_spinner( x, y )
	EntityLoad( "mods/pinball/files/explosive_gravity_spinner.xml", x, y )
end

function spawn_vine_monster( x, y )
	EntityLoad( "mods/pinball/files/vine_monster/vine_monster.xml", x, y )
end

function spawn_rock( x, y )
	EntityLoad( "mods/pinball/files/rock.xml", x, y )
end

function spawn_button4( x, y )
	EntityLoad( "mods/pinball/files/button4.xml", x, y )
end

function spawn_shield2( x, y )
	EntityLoad( "mods/pinball/files/shield2.xml", x, y )
end

function spawn_button5( x, y )
	EntityLoad( "mods/pinball/files/button5.xml", x, y )
end

function spawn_shield3( x, y )
	EntityLoad( "mods/pinball/files/shield3.xml", x, y )
end

function spawn_portal( x, y )
	EntityLoad( "mods/pinball/files/portal.xml", x, y )
end

function spawn_shield5( x, y )
	EntityLoad( "mods/pinball/files/shield5.xml", x, y )
end

function spawn_boss( x, y )
	EntityLoad( "mods/pinball/files/boss/boss_centipede.xml", x, y )
	LoadBackgroundSprite( "mods/pinball/files/boss/arena.png", x - 330, y - 175, 40.0, false )
end

function spawn_bomb( x, y )
	EntityLoad( "mods/pinball/files/bomb_spawner.xml", x, y )
end
