local function get_player_position()
  players = EntityGetWithTag("player_unit")
  if #players > 0 then
    return EntityGetTransform(players[1])
  end
end

function approx_rolling_average(avg, new_sample, n)
  avg = avg - avg / n;
  avg = avg + new_sample / n;
  return avg
end

local px, py = get_player_position()
local cx, cy = GameGetCameraPos()
GameSetCameraFree( true )
local x_new_average = approx_rolling_average(cx, px, 20)
local y_new_average = approx_rolling_average(cy, py, 20)
GameSetCameraPos( x_new_average, y_new_average )

--Close Wand Edit GUI
local player = GetUpdatedEntityID()
local inventory_gui_component = EntityGetFirstComponentIncludingDisabled(player, "InventoryGuiComponent")
ComponentSetValue2(inventory_gui_component, "mActive", false)

--Set Music Track
local audio_loop_component = EntityGetFirstComponent(player, "AudioLoopComponent", "music")

local mode = ModSettingGet( "pinball.music" )

if GlobalsGetValue("pinball_boss_start", "0") == "0" then
	if mode == "track1" or not mode then
	  if ComponentGetValue2(audio_loop_component, "event_name") ~= "pinball_mod/level1" then
		EntityRemoveComponent(player, audio_loop_component)
		EntityAddComponent(player, "AudioLoopComponent", {
			_tags="music",
			file="mods/pinball/files/audio/my_mod_audio.snd",
			event_name="pinball_mod/level1",
			auto_play="1"
		})
		GamePrint("Playing Track 1")
	  end
	elseif mode == "track2" then
	  if ComponentGetValue2(audio_loop_component, "event_name") ~= "pinball_mod/level4" then
		EntityRemoveComponent(player, audio_loop_component)
		EntityAddComponent(player, "AudioLoopComponent", {
			_tags="music",
			file="mods/pinball/files/audio/my_mod_audio.snd",
			event_name="pinball_mod/level4",
			auto_play="1"
		})
		GamePrint("Playing Track 2")
	  end
	elseif mode == "track3" then
	  if ComponentGetValue2(audio_loop_component, "event_name") ~= "pinball_mod/level3" then
		EntityRemoveComponent(player, audio_loop_component)
		EntityAddComponent(player, "AudioLoopComponent", {
			_tags="music",
			file="mods/pinball/files/audio/my_mod_audio.snd",
			event_name="pinball_mod/level3",
			auto_play="1"
		})
		GamePrint("Playing Track 3")
	  end
	elseif mode == "track4" then
	  if ComponentGetValue2(audio_loop_component, "event_name") ~= "pinball_mod/level5" then
		EntityRemoveComponent(player, audio_loop_component)
		EntityAddComponent(player, "AudioLoopComponent", {
			_tags="music",
			file="mods/pinball/files/audio/my_mod_audio.snd",
			event_name="pinball_mod/level5",
			auto_play="1"
		})
		GamePrint("Playing Track 3")
	  end
	elseif mode == "track5" then
	  if ComponentGetValue2(audio_loop_component, "event_name") ~= "pinball_mod/level2" then
		EntityRemoveComponent(player, audio_loop_component)
		EntityAddComponent(player, "AudioLoopComponent", {
			_tags="music",
			file="mods/pinball/files/audio/my_mod_audio.snd",
			event_name="pinball_mod/level2",
			auto_play="1"
		})
		GamePrint("Playing Track 5")
	  end
	end
elseif GlobalsGetValue("pinball_boss_start", "0") == "1" and GlobalsGetValue("pinball_ending", "0") == "0" then
  if ComponentGetValue2(audio_loop_component, "event_name") ~= "pinball_mod/boss" then
	EntityRemoveComponent(player, audio_loop_component)
	EntityAddComponent(player, "AudioLoopComponent", {
		_tags="music",
		file="mods/pinball/files/audio/my_mod_audio.snd",
		event_name="pinball_mod/boss",
		auto_play="1"
	})
  end
elseif GlobalsGetValue("pinball_boss_start", "0") == "1" and GlobalsGetValue("pinball_ending", "0") == "1" then
  if audio_loop_component > 0 then
	EntityRemoveComponent(player, audio_loop_component)
  end
end

--Buoyancy
-- local entity_id = players[1]

-- local velocity_component = EntityGetFirstComponentIncludingDisabled(entity_id, "VelocityComponent")

-- local x, y, rot = EntityGetTransform( entity_id )

-- local corner_in_water, hit_x, hit_y = RaytraceSurfacesAndLiquiform( x, y, x, y )
-- local corner_in_solid, hit_x2, hit_y2 = RaytracePlatforms( x, y, x, y )

-- if corner_in_water and not corner_in_solid then
	-- if velocity_component > 0 then
		-- print('velocity_component (' .. tostring(velocity_component) .. ':'.. type(velocity_component) .. ')')
		-- local vel_x,vel_y = ComponentGetValue2( velocity_component, "mVelocity" )
		-- ComponentSetValue2(velocity_component, "mVelocity", vel_x, vel_y - 2)
	-- end
-- end

--Disabling lua scripts offscreen

-- dofile_once( "data/scripts/lib/utilities.lua" )

-- function get_player()
  -- local players = get_players()
  -- if players ~= nil then
    -- return players[1]
  -- end

  -- -- TODO: What does this mean anyway? Player is dead..?
  -- return nil
-- end

-- local entities = EntityGetInRadius(px, py, 99999)
-- local entity_id = GetUpdatedEntityID()

-- for i, entity in ipairs(entities) do
	-- if entity ~= entity_id and entity ~= get_player() then
		-- local x, y = EntityGetTransform( entity )
		-- local distance = get_distance( px, py, x, y )
		-- if distance > 200 then
			-- local lua_comps = EntityGetComponent(entity, "LuaComponent") or {}
			-- if #lua_comps > 0 then
				-- for i, comp in ipairs(lua_comps) do
					-- EntitySetComponentIsEnabled( entity, comp, false )
				-- end
			-- end
		-- else
			-- local lua_comps = EntityGetComponent(entity, "LuaComponent") or {}
			-- if #lua_comps > 0 then
				-- for i, comp in ipairs(lua_comps) do
					-- EntitySetComponentIsEnabled( entity, comp, true )
				-- end
			-- end
		-- end
	-- end
-- end