dofile_once( "data/scripts/lib/utilities.lua" )

--Bumper part

local entity_id = GetUpdatedEntityID()

local x, y = EntityGetTransform( entity_id )

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

local projectiles = EntityGetWithTag( "player_unit" )
local non_player_projectile = EntityGetInRadiusWithTag( x, y, 11, "projectile" )

local direction_random = 0
if ( ( #projectiles > 0 ) and ( GlobalsGetValue("pinball_respawn_in_progress", "0") == "0" ) ) or ( #non_player_projectile > 0 ) then
	for i,projectile_id in ipairs(projectiles) do	
		local px, py = EntityGetTransform( projectile_id )
		-- EntitySetComponentsWithTagEnabled(projectile_id, "start", true)
		local distance = math.abs( x - px ) + math.abs( y - py )
		local distance_full = 11
		
		if ( distance < distance_full * 1.25 ) then
			distance = get_distance( px, py, x, y )
			direction = get_direction( px, py, x, y )
	
			if ( distance < distance_full ) then
				local velocitycomponents = EntityGetComponent( projectile_id, "VelocityComponent" )
				
				local gravity_percent = math.max(( distance_full - distance ) / distance_full, 0.01)
				local gravity_coeff = 1000000000000000
				
				if ( velocitycomponents ~= nil ) then
					edit_component( projectile_id, "VelocityComponent", function(comp,vars)
						local vel_x,vel_y = ComponentGetValueVector2( comp, "mVelocity", vel_x, vel_y)
						
						local offset_x = math.cos( direction + direction_random ) * ( gravity_coeff * gravity_percent )
						local offset_y = 0 - math.sin( direction + direction_random ) * ( gravity_coeff * gravity_percent )

						vel_x = vel_x + offset_x
						vel_y = vel_y + offset_y
						
						local lua_comps = EntityGetComponent(projectile_id, "LuaComponent") or {}
						
						for i, lua_comp in ipairs(lua_comps) do
						
							if ComponentGetValue2(lua_comp, "script_source_file") ~= "mods/pinball/files/scripts/speed_toggler_off.lua" then

								ComponentSetValue2( comp, "terminal_velocity", 800)

								EntityAddComponent(projectile_id, "LuaComponent", {
									script_source_file="mods/pinball/files/scripts/speed_toggler_off.lua",
									execute_every_n_frame=40,
									execute_on_added=0,
								})
								
							end
							
						end
						
						ComponentSetValueVector2( comp, "mVelocity", vel_x, vel_y)
					end)
					EntityLoad("mods/pinball/files/bounce_sparks_explosive.xml", px, py)
				end
			end
		end
	end
	for i,projectile_id in ipairs(non_player_projectile) do	
		local px, py = EntityGetTransform( projectile_id )
		-- EntitySetComponentsWithTagEnabled(projectile_id, "start", true)
		local distance = math.abs( x - px ) + math.abs( y - py )
		local distance_full = 11
		
		if ( distance < distance_full * 1.25 ) then
			distance = get_distance( px, py, x, y )
			direction = get_direction( px, py, x, y )
	
			if ( distance < distance_full ) then
				local velocitycomponents = EntityGetComponent( projectile_id, "VelocityComponent" )
				
				local gravity_percent = math.max(( distance_full - distance ) / distance_full, 0.01)
				local gravity_coeff = 1000000000000000
				
				if ( velocitycomponents ~= nil ) then
					edit_component( projectile_id, "VelocityComponent", function(comp,vars)
						local vel_x,vel_y = ComponentGetValueVector2( comp, "mVelocity", vel_x, vel_y)
						
						local offset_x = math.cos( direction + direction_random ) * ( gravity_coeff * gravity_percent )
						local offset_y = 0 - math.sin( direction + direction_random ) * ( gravity_coeff * gravity_percent )

						vel_x = vel_x + offset_x
						vel_y = vel_y + offset_y
						
						local lua_comps = EntityGetComponent(projectile_id, "LuaComponent") or {}
						
						for i, comp in ipairs(lua_comps) do
						
							if ComponentGetValue2(comp, "script_source_file") ~= "mods/pinball/files/scripts/speed_toggler_off.lua" then

								ComponentSetValue2( comp, "terminal_velocity", 600)

								EntityAddComponent(projectile_id, "LuaComponent", {
									script_source_file="mods/pinball/files/scripts/speed_toggler_off.lua",
									execute_every_n_frame=40,
									execute_on_added=0,
								})
								
							end
							
						end
						
						ComponentSetValueVector2( comp, "mVelocity", vel_x, vel_y)
					end)
					EntityLoad("mods/pinball/files/bounce_sparks_explosive.xml", px, py)
				end
			end
		end
	end
end

--Gravity part

dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local projectiles = EntityGetWithTag( "player_unit" )

if ( #projectiles > 0 ) then
	for i,projectile_id in ipairs(projectiles) do	
		local px, py = EntityGetTransform( projectile_id )
		
		local distance = math.abs( x - px ) + math.abs( y - py )
		local distance_full = 117
		
		if ( distance < distance_full * 1.25 ) and ( entity_id ~= projectile_id ) then
			distance = math.sqrt( ( x - px ) ^ 2 + ( y - py ) ^ 2 )
			direction = 0 - math.atan2( ( y - py ), ( x - px ) )
	
			if ( distance < distance_full ) then
				local velocitycomponents = EntityGetComponent( projectile_id, "VelocityComponent" )
				
				local gravity_percent = math.max(( distance_full - distance ) / distance_full, 0.2)
				local gravity_coeff = 20
				
				if ( velocitycomponents ~= nil ) then
					edit_component( projectile_id, "VelocityComponent", function(comp,vars)
						local vel_x,vel_y = ComponentGetValueVector2( comp, "mVelocity")
						
						local offset_x = math.cos( direction ) * ( gravity_coeff * gravity_percent )
						local offset_y = 0 - math.sin( direction ) * ( gravity_coeff * gravity_percent )

						vel_x = vel_x + offset_x
						vel_y = vel_y + offset_y

						ComponentSetValueVector2( comp, "mVelocity", vel_x, vel_y)
					end)
				end
			end
		end
	end
end

--Spinner part
local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local all_children = EntityGetAllChildren(entity_id)
local star_container
if all_children ~= nil then
  for i, child in ipairs(all_children) do
    if EntityGetName(child) == "star_container" then
      star_container = child
    end
  end
end

function get_state()
  local entity_id = GetUpdatedEntityID()
  state = state or {}
  state[entity_id] = state[entity_id] or {}
  return state[entity_id]
end

local num_stars = 3
local radius = 84
local rotation_speed = 1
local state = get_state()

local var_comp = EntityGetFirstComponent(entity_id, "VariableStorageComponent", "initialised")
local boolean = ComponentGetValue2(var_comp, "value_bool")

if boolean == false then
  ComponentSetValue2(var_comp, "value_bool", true)
end

if star_container ~= nil and boolean == true then
  local all_stars = EntityGetAllChildren(star_container)
  if all_stars == nil then
    SetRandomSeed(GameGetFrameNum() + entity_id, GameGetFrameNum())
    for i=1, num_stars do
      local angle = math.rad(360 / num_stars * i)
      local star = EntityLoad("mods/pinball/files/bad_thing.xml", x + math.cos(angle) * radius, y + math.sin(angle) * radius)
      EntityAddChild(star_container, star)
    end
  else
    state.tick = (state.tick or 0) + rotation_speed
    if all_stars ~= nil then
      for i, star in ipairs(all_stars) do
        local angle = math.rad(360 / #all_stars * i + state.tick)
        EntitySetTransform(star, x + math.cos(angle) * radius, y + math.sin(angle) * radius)
      end
    end
  end
end