dofile_once("data/scripts/lib/utilities.lua")

function get_player()
  local players = get_players()
  if players ~= nil then
    return players[1]
  end

  -- TODO: What does this mean anyway? Player is dead..?
  return nil
end

--Close Wand Edit GUI
local entity_id = get_player()
local inventory_gui_component = EntityGetFirstComponentIncludingDisabled(entity_id, "InventoryGuiComponent")
ComponentSetValue2(inventory_gui_component, "mActive", false)

function fake_death()

	local entity_id = get_player()
	local x, y, rot = EntityGetTransform(entity_id)

	if GlobalsGetValue("pinball_ending", "0") == "0" then

	  GlobalsSetValue("pinball_respawn_in_progress", "1")
	  GlobalsSetValue("pinball_star1_number", 0)
	  GlobalsSetValue("pinball_star2_number", 0)
	  GlobalsSetValue("pinball_star3_number", 0)
	  GlobalsSetValue("pinball_star4_number", 0)
	  GlobalsSetValue("pinball_star4_2_number", 0)
	  GlobalsSetValue("pinball_star5_number", 0)

	  --disable sprite
	  local sprite_component = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteComponent")
	  EntitySetComponentIsEnabled( entity_id, sprite_component, false )
	  
	  edit_component( entity_id, "VelocityComponent", function(comp,vars)
	  	ComponentSetValueVector2( comp, "mVelocity", 0, 0)
	  end)
	  
	  EntitySetComponentsWithTagEnabled(entity_id, "controls", false)
	  
	  SetTimeOut(3, "mods/pinball/files/head_checker.lua", "respawn")
	  
	end
  
end

function respawn()

	local entity_id = get_player()
	local x, y, rot = EntityGetTransform(entity_id)
	
	local respawn_x = tonumber(GlobalsGetValue("pinball_respawn_x", "-778"))
	local respawn_y = tonumber(GlobalsGetValue("pinball_respawn_y", "-812"))

	EntityApplyTransform(entity_id, respawn_x, respawn_y, 0)

	--enable sprite
	local sprite_component = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteComponent")
	EntitySetComponentIsEnabled( entity_id, sprite_component, true )
	
	-- EntitySetComponentsWithTagEnabled(entity_id, "controls", true)
	GlobalsSetValue("pinball_player_health", 5)
	local boss_entity = EntityGetWithName("The Boss")
	if boss_entity > 0 and GlobalsGetValue("pinball_boss_start", "0") == "1" then
		local comp = EntityGetFirstComponent( boss_entity, "DamageModelComponent" )
		if ( comp ~= nil ) then
			local max_hp = ComponentGetValue2( comp, "max_hp" )
			ComponentSetValue2( comp, "hp", max_hp )
		end
	end
	GlobalsSetValue("pinball_respawn_in_progress", "0")

end

function reset()

	local entity_id = get_player()
	local x, y, rot = EntityGetTransform(entity_id)

	if GlobalsGetValue("pinball_ending", "0") == "0" then

	  GlobalsSetValue("pinball_respawn_in_progress", "1")
	  GlobalsSetValue("pinball_star1_number", 0)
	  GlobalsSetValue("pinball_star2_number", 0)
	  GlobalsSetValue("pinball_star3_number", 0)
	  GlobalsSetValue("pinball_star4_number", 0)
	  GlobalsSetValue("pinball_star4_2_number", 0)
	  GlobalsSetValue("pinball_star5_number", 0)

	  --disable sprite
	  local sprite_component = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteComponent")
	  EntitySetComponentIsEnabled( entity_id, sprite_component, false )
	  
	  edit_component( entity_id, "VelocityComponent", function(comp,vars)
	  	ComponentSetValueVector2( comp, "mVelocity", 0, 0)
	  end)
	  
	  EntitySetComponentsWithTagEnabled(entity_id, "controls", false)
	  
	  SetTimeOut(2, "mods/pinball/files/head_checker.lua", "respawn2")
	  
	end
  
end

function respawn2()

	local entity_id = get_player()
	local x, y, rot = EntityGetTransform(entity_id)
	
	local respawn_x = tonumber(GlobalsGetValue("pinball_respawn_x", "-778"))
	local respawn_y = tonumber(GlobalsGetValue("pinball_respawn_y", "-812"))

	EntityApplyTransform(entity_id, respawn_x, respawn_y, 0)

	--enable sprite
	local sprite_component = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteComponent")
	EntitySetComponentIsEnabled( entity_id, sprite_component, true )

	GlobalsSetValue("pinball_respawn_in_progress", "0")

end