dofile_once( "data/scripts/lib/utilities.lua" )

--Bumper part

local entity_id = GetUpdatedEntityID()

local x, y = EntityGetTransform( entity_id )

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

local projectiles = EntityGetWithTag( "player_unit" )
local non_player_projectile = EntityGetInRadiusWithTag( x, y, 11, "projectile" )

local direction_random = 0
if ( ( #projectiles > 0 ) and ( GlobalsGetValue("pinball_respawn_in_progress", "0") == "0" ) ) or ( #non_player_projectile > 0 ) then
	for i,projectile_id in ipairs(projectiles) do	
		local px, py = EntityGetTransform( projectile_id )
		-- EntitySetComponentsWithTagEnabled(projectile_id, "start", true)
		local distance = math.abs( x - px ) + math.abs( y - py )
		local distance_full = 11
		
		if ( distance < distance_full * 1.25 ) then
			distance = get_distance( px, py, x, y )
			direction = get_direction( px, py, x, y )
	
			if ( distance < distance_full ) then
				local velocitycomponents = EntityGetComponent( projectile_id, "VelocityComponent" )
				
				local gravity_percent = math.max(( distance_full - distance ) / distance_full, 0.01)
				local gravity_coeff = 1000000000000000
				
				if ( velocitycomponents ~= nil ) then
					edit_component( projectile_id, "VelocityComponent", function(comp,vars)
						local vel_x,vel_y = ComponentGetValueVector2( comp, "mVelocity", vel_x, vel_y)
						
						local offset_x = math.cos( direction + direction_random ) * ( gravity_coeff * gravity_percent )
						local offset_y = 0 - math.sin( direction + direction_random ) * ( gravity_coeff * gravity_percent )

						vel_x = vel_x + offset_x
						vel_y = vel_y + offset_y
						
						local lua_comps = EntityGetComponent(projectile_id, "LuaComponent") or {}
						
						for i, lua_comp in ipairs(lua_comps) do
						
							if ComponentGetValue2(lua_comp, "script_source_file") ~= "mods/pinball/files/scripts/speed_toggler_off.lua" then

								ComponentSetValue2( comp, "terminal_velocity", 800)

								EntityAddComponent(projectile_id, "LuaComponent", {
									script_source_file="mods/pinball/files/scripts/speed_toggler_off.lua",
									execute_every_n_frame=40,
									remove_after_executed=1,
									execute_on_added=0,
								})
								
							end
							
						end
						
						ComponentSetValueVector2( comp, "mVelocity", vel_x, vel_y)
					end)
					EntityLoad("mods/pinball/files/bounce_sparks_explosive.xml", px, py)
				end
			end
		end
	end
	for i,projectile_id in ipairs(non_player_projectile) do	
		local px, py = EntityGetTransform( projectile_id )
		-- EntitySetComponentsWithTagEnabled(projectile_id, "start", true)
		local distance = math.abs( x - px ) + math.abs( y - py )
		local distance_full = 11
		
		if ( distance < distance_full * 1.25 ) then
			distance = get_distance( px, py, x, y )
			direction = get_direction( px, py, x, y )
	
			if ( distance < distance_full ) then
				local velocitycomponents = EntityGetComponent( projectile_id, "VelocityComponent" )
				
				local gravity_percent = math.max(( distance_full - distance ) / distance_full, 0.01)
				local gravity_coeff = 1000000000000000
				
				if ( velocitycomponents ~= nil ) then
					edit_component( projectile_id, "VelocityComponent", function(comp,vars)
						local vel_x,vel_y = ComponentGetValueVector2( comp, "mVelocity", vel_x, vel_y)
						
						local offset_x = math.cos( direction + direction_random ) * ( gravity_coeff * gravity_percent )
						local offset_y = 0 - math.sin( direction + direction_random ) * ( gravity_coeff * gravity_percent )

						vel_x = vel_x + offset_x
						vel_y = vel_y + offset_y
						
						local lua_comps = EntityGetComponent(projectile_id, "LuaComponent") or {}
						
						for i, comp in ipairs(lua_comps) do
						
							if ComponentGetValue2(comp, "script_source_file") ~= "mods/pinball/files/scripts/speed_toggler_off.lua" then

								ComponentSetValue2( comp, "terminal_velocity", 600)

								EntityAddComponent(projectile_id, "LuaComponent", {
									script_source_file="mods/pinball/files/scripts/speed_toggler_off.lua",
									execute_every_n_frame=40,
									execute_on_added=0,
								})
								
							end
							
						end
						
						ComponentSetValueVector2( comp, "mVelocity", vel_x, vel_y)
					end)
					EntityLoad("mods/pinball/files/bounce_sparks_explosive.xml", px, py)
				end
			end
		end
	end
end