dofile_once("data/scripts/lib/utilities.lua")

--Adding custom material
ModMaterialsFileAdd("mods/pinball/files/materials/materials.xml")

--Adding Translations
--Addition of custom translations
local content = ModTextFileGetContent("data/translations/common.csv")
ModTextFileSetContent("data/translations/common.csv", content .. [[
pinball_bad_thing,Bad Thing,Бутылочная ярость,,,,,,,,まっくろくろすけ,,,,
pinball_bad_thing_desc,Spawn A Bad Thing,Бутылочная ярость,,,,,,,,恐ろしい敵が召喚された,,,,
pinball_super_speed,Super Speed,Бутылочная ярость,,,,,,,,スーパースピード,,,,
pinball_super_speed_desc,Give Mina Super Speed,Бутылочная ярость,,,,,,,,公道最速だ！,,,,
pinball_no_gravity,No Gravity,Бутылочная ярость,,,,,,,,無重力,,,,
pinball_no_gravity_desc,Give Mina 0 Gravity,Бутылочная ярость,,,,,,,,地球は青かった,,,,
pinball_invert_gravity,Inverted Gravity,Бутылочная ярость,,,,,,,,重力反転,,,,
pinball_invert_gravity_desc,Give Mina Inverted Gravity,Бутылочная ярость,,,,,,,,ヒューストン、問題が発生した,,,,
pinball_gravity_field,Gravity Field,Бутылочная ярость,,,,,,,,重力フィールド召喚,,,,
pinball_gravity_field_desc,Spawn in a gravity field,Бутылочная ярость,,,,,,,,物体が引き寄せられていく！,,,,
pinball_bumper,Bumper,Бутылочная ярость,,,,,,,,バンパー召喚,,,,
pinball_bumper_desc,Spawn in a Bumper,Бутылочная ярость,,,,,,,,新しいバンパーが召喚された,,,,
pinball_bumper_explosive,Explosive Bumper,Бутылочная ярость,,,,,,,,爆裂バンパー召喚,,,,
pinball_bumper_explosive_desc,Spawn in an Explosive Bumper,Бутылочная ярость,,,,,,,,すごい反発力だ！,,,,
pinball_vine_monster,Kelp Monster,Бутылочная ярость,,,,,,,,触手生物,,,,
pinball_vine_monster_desc,Spawn in a Kelp Monster,Бутылочная ярость,,,,,,,,ああ、窓に！窓に！,,,,
]])

--Adding visual compatibility with NT
function replace_value(path, input, output, print_contents)
	local content = ModTextFileGetContent(path)
	content = content:gsub(input, output)
	ModTextFileSetContent(path, content)
	if print_contents == true then
		print(content)
	end
end

if ModIsEnabled("noita-together") then
	-- ModLuaFileAppend( "mods/noita-together/files/scripts/utils.lua", "mods/pinball/files/nt/spawnplayerghost.lua" )
	replace_value("mods/noita-together/files/scripts/util/player_ghosts.lua", 
	[[mods%/noita%-together%/files%/entities%/]],
	[[mods/pinball/files/nt/]], true
	)
end

--Adding the sounds you got from FMOD:
ModRegisterAudioEventMappings("mods/pinball/files/audio/GUIDs.txt")

ModMagicNumbersFileAdd("mods/pinball/files/magic_numbers.xml")
ModMaterialsFileAdd("mods/pinball/files/materials.xml")

--set ground not to spawn moss strength
local nxml = dofile_once("mods/pinball/lib/nxml.lua")
local content = ModTextFileGetContent("data/materials.xml")
local xml = nxml.parse(content)
for element in xml:each_child() do
  if element.attr.name == "rock_hard" then
    element.attr._inherit_reactions = 0
	element.attr.hp = 999999
	element.attr.durability = 99999
  end
end
ModTextFileSetContent("data/materials.xml", tostring(xml))

replace_value("data/materials.xml", 
[[data%/materials_gfx%/rock_hard%.png]],
[[mods/pinball/files/materials/rock_hard.png]]
)

-- ModLuaFileAppend("data/scripts/init.lua", "mods/bike/files/init_append.lua")

function OnPlayerSpawned(player_entity)
  if (GlobalsGetValue("pinball_mod_load_done", 0) == "1") then
    return
  end
  
  GlobalsSetValue("pinball_player_health", 5)
  
  local x, y = EntityGetTransform(player_entity)
  
  local cursor_id = EntityLoad( "mods/pinball/files/bumper_mouse.xml", x, y )
  EntityAddChild(player_entity, cursor_id)
  EntityAddComponent2(cursor_id, "LuaComponent", {
    script_source_file="mods/pinball/files/update.lua",
    execute_every_n_frame=1,
    execute_on_added=false,
  })
  GlobalsSetValue("pinball_mod_load_done", "1")
end

function OnWorldPreUpdate()
	local world_state_entity = GameGetWorldStateEntity()
	edit_component( world_state_entity, "WorldStateComponent", function(comp,vars)
		vars.time = 0
		vars.time_dt = 0
		vars.fog = 0
		vars.fog_target = 0
		vars.fog_target_extra = 0
		vars.rain = 0
		vars.rain_target = 0
		vars.rain_target_extra = 0
		vars.intro_weather = 1
		vars.open_fog_of_war_everywhere = 1
	end)

    --Adding gui to force death
    local id = 2
    local function new_id()
      id = id + 1
      return id
    end
	
    gui = gui or GuiCreate()
    GuiStartFrame(gui)
	GuiLayoutBeginVertical(gui, 90, 2)
	
    if GuiButton(gui, new_id(), 0, 0, "Reset") then
		if GlobalsGetValue("pinball_respawn_in_progress", "0") == "0" then
		  SetTimeOut(0, "mods/pinball/files/head_checker.lua", "reset")
		end
    end
    GuiLayoutEnd(gui)
end

function OnPlayerDied(player)
end

function OnPausedChanged( is_paused, is_inventory_pause )
end