dofile("data/scripts/lib/mod_settings.lua")

local currentLang = GameTextGetTranslatedOrNot("$current_language")

local music_title = "Music Selection"
local music_description = "Select the music track you want to hear"
local track1 = "Track 1"
local track2 = "Track 2"
local track3 = "Track 3"
local track4 = "Track 4"
local track5 = "Track 5"
local bump_title = "Bump with other players"
local bump_description = "Toggle bumping into players when playing with Noita Together"

--Russian Translations
if currentLang == "русский" then

	music_title = "Music Selection"
	music_description = "Select the music track you want to hear"
	track1 = "Track 1"
	track2 = "Track 2"
	track3 = "Track 3"
	track4 = "Track 4"
	track5 = "Track 5"
	bump_title = "Bump with other players"
	bump_description = "Toggle bumping into players when playing with Noita Together"

--Japanese Translation
elseif currentLang == "日本語" then

    music_title = "BGM"
    music_description = "BGMを選択してください"
    track1 = "Track 1"
    track2 = "Track 2"
    track3 = "Track 3"
    track4 = "Track 4"
    track5 = "Track 5"
    bump_title = "マルチプレイ用機能"
    bump_description = "オンすると、Noita Together使用時に他プレイヤーとの当たり判定が発生します"

end

local mod_id = "pinball"
mod_settings_version = 1
mod_settings =
{
    {
        id = "music",
        ui_name = music_title,
        ui_description = music_description,
        value_default = "track1",
        values = {
            {"track1", track1},
            {"track2", track2},
			{"track3", track3},
			{"track4", track4},
			{"track5", track5},
        },
        scope = MOD_SETTING_SCOPE_RUNTIME,
    },
	  {
		id = "bump",
		ui_name = bump_title,
		ui_description = bump_description,
		value_default = true,
		scope = MOD_SETTING_SCOPE_RUNTIME,
	  },
}

function ModSettingsUpdate( init_scope )
    local old_version = mod_settings_get_version( mod_id )
    mod_settings_update( mod_id, mod_settings, init_scope )
end

function ModSettingsGuiCount()
    return mod_settings_gui_count( mod_id, mod_settings )
end

function ModSettingsGui( gui, in_main_menu )
    mod_settings_gui( mod_id, mod_settings, gui, in_main_menu )
end
